/*--------------------------------------------------------------------
 * $Id: cloud3d.h,v 1.1 2005/12/13 14:52:21 bernhard Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __cloud3d_h
#define __cloud3d_h

#include <stdio.h>
#include "uvspec.h"
#include "mystic.h"

int calloc_1D_atmos (atmosphere_struct *atmos, int nlyr);

profile *calloc_profile (int n);
profile3D *calloc_profile3D (int Nz, int Nx, int Ny, int *threed);

int setup_atmosphere3D (input_struct input, output_struct *output);

int setup_profiles1D (float *dtair, float *dto3, 
		      float *dtaer, float *omaer, float *g1aer, float *g2aer, float *faer,
		      float *dtcld, float *omcld, float *g1cld, float *g2cld, float *fcld,
		      float *dtice, float *omice, float *g1ice, float *g2ice, float *fice,
		      float *lwccld, float *recld,
		      float *zprof, int nlyr,
		      atmosphere_struct *atmos);



#endif



